# Ejemplo de uso de la librería pygad para definir algoritmos genéticos que
# obtengan los coeficientes de una combinación lineal

import pygad
import numpy as np

def fitness(instancia, solucion, indice):
    salida = np.sum(solucion*valores_x)
    resultado_fitness = 1.0 / (np.abs(salida - resultado) + \
        0.000001)    
    return resultado_fitness

resultado = 30
valores_x = [2, 3, 5, 7]

instancia_ga = pygad.GA(num_generations=100,
                       sol_per_pop=10,
                       num_genes=len(valores_x),
                       num_parents_mating=2,
                       fitness_func=fitness,
                       mutation_type="random",
                       mutation_probability=0.6)

instancia_ga.run()

solucion, fitness_solucion, indice_solucion = instancia_ga.best_solution()
print(f"Parámetros de la mejor solución:\n{solucion}")
print(f"Fitness de la mejor solución: {fitness_solucion}")
print(f"Índice de la mejor solución: {indice_solucion}")

instancia_ga.plot_fitness()
